org.apache.poi.xslf.usermodel

## Class XSLFTable

- java.lang.Object
- - org.apache.poi.xslf.usermodel.XSLFShape
  - - org.apache.poi.xslf.usermodel.XSLFGraphicFrame
    - - org.apache.poi.xslf.usermodel.XSLFTable

- All Implemented Interfaces:
    java.lang.Iterable<XSLFTableRow>, GraphicalFrame<XSLFShape,XSLFTextParagraph>, PlaceableShape<XSLFShape,XSLFTextParagraph>, Shape<XSLFShape,XSLFTextParagraph>, TableShape<XSLFShape,XSLFTextParagraph>

      public class XSLFTable
      extends XSLFGraphicFrame
      implements java.lang.Iterable<XSLFTableRow>, TableShape<XSLFShape,XSLFTextParagraph>

  Represents a table in a .pptx presentation

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.poi.xslf.usermodel.XSLFShape

      `XSLFShape.ReparseFactory<T extends org.apache.xmlbeans.XmlObject>`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addColumn()` Add a new column at the end of the table.
    `XSLFTableRow` | `addRow()`
    `XSLFTableCell` | `getCell(int row, int col)` Gets a cell
    `double` | `getColumnWidth(int idx)` Gets the width (in points) of the n-th column
    `org.openxmlformats.schemas.drawingml.x2006.main.CTTable` | `getCTTable()`
    `int` | `getNumberOfColumns()` Return the maximum number of columns.
    `int` | `getNumberOfRows()` Return the number of rows
    `double` | `getRowHeight(int row)` Gets the row height
    `java.util.List<XSLFTableRow>` | `getRows()`
    `protected XSLFTableStyle` | `getTableStyle()` Get assigned TableStyle
    `void` | `insertColumn(int colIdx)` Insert a new column at the given index.
    `java.util.Iterator<XSLFTableRow>` | `iterator()`
    `void` | `mergeCells(int firstRow, int lastRow, int firstCol, int lastCol)` Merge cells of a table
    `void` | `removeColumn(int colIdx)` Remove the column at the given index.
    `void` | `removeRow(int rowIdx)` Remove the row on the given index
    `void` | `setColumnWidth(int idx, double width)` Sets the width (in points) of the n-th column
    `void` | `setRowHeight(int row, double height)` Sets the row height.
    `void` | `updateCellAnchor()` Calculates the bounding boxes of all cells and updates the dimension of the table

    - ### Methods inherited from class org.apache.poi.xslf.usermodel.XSLFGraphicFrame

      `getAnchor, getChart, getFallbackPicture, getFlipHorizontal, getFlipVertical, getRotation, getShapeType, hasChart, setAnchor, setFlipHorizontal, setFlipVertical, setRotation`

    - ### Methods inherited from class org.apache.poi.xslf.usermodel.XSLFShape

      `draw, fetchShapeProperty, getBgPr, getBgRef, getChild, getCNvPr, getFillPaint, getGrpSpPr, getParent, getPlaceholder, getPlaceholderDetails, getShapeId, getShapeName, getShapeProperties, getSheet, getSpStyle, getXmlObject, isPlaceholder, selectPaint, selectPaint, selectPaint, selectPaint, selectPaint, selectProperty, selectProperty, setParent, setPlaceholder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.Shape

      `draw, getAnchor, getParent, getShapeId, getShapeName, getSheet`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.PlaceableShape

      `getAnchor, getFlipHorizontal, getFlipVertical, getParent, getRotation, getSheet, setAnchor, setFlipHorizontal, setFlipVertical, setRotation`

- - ### Method Detail

    - #### getCell

          public XSLFTableCell getCell(int row,
                                       int col)

      Description copied from interface: `TableShape`
      Gets a cell
      Specified by:
        `getCell` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `row` - the row index (0-based)
        `col` - the column index (0-based)
      Returns:
        the cell or null if the cell doesn't exists, e.g. when accessing a merged cell or if the index is out of bounds

    - #### getCTTable

          @Internal
          public org.openxmlformats.schemas.drawingml.x2006.main.CTTable getCTTable()

    - #### getNumberOfColumns

          public int getNumberOfColumns()

      Description copied from interface: `TableShape`
      Return the maximum number of columns. If the table contains merged cells, the number of columns might be less than the maximum.
      Specified by:
        `getNumberOfColumns` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the maximum number of column

    - #### getNumberOfRows

          public int getNumberOfRows()

      Description copied from interface: `TableShape`
      Return the number of rows
      Specified by:
        `getNumberOfRows` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the row count

    - #### getColumnWidth

          public double getColumnWidth(int idx)

      Description copied from interface: `TableShape`
      Gets the width (in points) of the n-th column
      Specified by:
        `getColumnWidth` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `idx` - the column index (0-based)
      Returns:
        the width (in points)

    - #### setColumnWidth

          public void setColumnWidth(int idx,
                                     double width)

      Description copied from interface: `TableShape`
      Sets the width (in points) of the n-th column
      Specified by:
        `setColumnWidth` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `idx` - the column index (0-based)
        `width` - the width (in points)

    - #### getRowHeight

          public double getRowHeight(int row)

      Description copied from interface: `TableShape`
      Gets the row height
      Specified by:
        `getRowHeight` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `row` - the row index (0-based)
      Returns:
        the height (in points)

    - #### setRowHeight

          public void setRowHeight(int row,
                                   double height)

      Description copied from interface: `TableShape`
      Sets the row height.
      Specified by:
        `setRowHeight` in interface `TableShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `row` - the row index (0-based)
        `height` - the height to set (in points)

    - #### iterator

          public java.util.Iterator<XSLFTableRow> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<XSLFTableRow>`

    - #### getRows

          public java.util.List<XSLFTableRow> getRows()

    - #### addRow

          public XSLFTableRow addRow()

    - #### removeRow

          public void removeRow(int rowIdx)

      Remove the row on the given index
      Parameters:
        `rowIdx` - the row index

    - #### addColumn

          public void addColumn()

      Add a new column at the end of the table.
      Since:
        POI 4.1.2

    - #### insertColumn

          public void insertColumn(int colIdx)

      Insert a new column at the given index.
      Parameters:
        `colIdx` - the column index.
      Since:
        POI 4.1.2

    - #### removeColumn

          public void removeColumn(int colIdx)

      Remove the column at the given index.
      Parameters:
        `colIdx` - the column index.
      Since:
        POI 4.1.2

    - #### mergeCells

          public void mergeCells(int firstRow,
                                 int lastRow,
                                 int firstCol,
                                 int lastCol)

      Merge cells of a table

    - #### getTableStyle

          protected XSLFTableStyle getTableStyle()

      Get assigned TableStyle
      Returns:
        the assigned TableStyle
      Since:
        POI 3.15-beta2

    - #### updateCellAnchor

          public void updateCellAnchor()

      Calculates the bounding boxes of all cells and updates the dimension of the table

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.